@echo off
cd /d "%~dp0"
color 0e
title mRatio Fixer v7 / Uninstaller

rem Cheap (but effective) method of checking for administrator privileges
net session 1>nul 2>&1 && goto main
title mRatio Fixer v7 / Error
echo This script requires administrator privileges. To run it, you should:
echo   * Right-click on %~nx0
echo   * Click on "Run as administrator"
echo   * Click on "Yes" in the User Account Control prompt
echo.
echo Press any key to exit...&pause >nul&exit /b

:main
echo This script will uninstall mRatio Fixer. To be more specific, it will:
echo   * Stop the associated process, or service (if applicable)
echo   * Delete the service (if applicable)
echo   * Delete the service's log file (if applicable)
echo   * Remove the root certificate from Windows' certificate store
echo   * Delete the files associated with the certificate
echo   * Reset all Schannel registry settings to their default values
echo   * Delete the "firstrun" file created after running for the first time
echo   * Delete mRatio 5.4.1's original executable (used by inst_patch.bat)
echo   * Delete very old files left over from in-place updates
echo.
:prompt
choice /c yn /n /m "Do you want to uninstall mRatio Fixer now? (y/n)"
if %ERRORLEVEL%==1 echo Okay, continuing.&goto next
if %ERRORLEVEL%==2 goto exit
echo Invalid choice, press a key and try again.
pause >nul
goto prompt

:next
echo.
echo Working...

net stop mitmproxy 1>nul 2>&1
sc delete mitmproxy 1>nul 2>&1
rem TODO: it would be better to check SC's success and run this conditionally rather than always doing so
rem Also, this block is a near-duplicate of stop.bat, but I can't CALL that because it has an interactive prompt
for /f "usebackq tokens=2 delims=," %%a in (`tasklist /nh /fo CSV /fi "IMAGENAME eq mitmdump.---" /fi "MEMUSAGE gt 10000"`) do (
	windows-kill.--- -SIGBREAK %%a 1>nul 2>&1
	)
del /f /q mitmproxy.log 1>nul 2>&1
certutil -delstore "Root" "mitmproxy" 1>nul 2>&1
del /f /q "mitmproxy-dhparam.pem" "mitmproxy-ca-cert.pem" "mitmproxy-ca-cert.p12" "mitmproxy-ca-cert.cer" "mitmproxy-ca.pem" "mitmproxy-ca.p12" 1>nul 2>&1
regedit /s "registry_u.---"
del /f /q "firstrun" 1>nul 2>&1
del /f /q "mRatio.exe" 1>nul 2>&1
del /f /q "mitmweb.---" "install.bat" "runme.bat" "service.bat" "redirect.py" "windows-kill.x64" "windows-kill.x86" 1>nul 2>&1

echo Done.
goto exit

:exit
echo Press any key to exit...
pause >nul
exit /b
